Index: i18n/Ukrainian.ts
===================================================================
--- i18n/Ukrainian.ts	(revision 5fce5619059cf67deabb001c174732bf3cf8fa89)
+++ i18n/Ukrainian.ts	(revision 5587b87fac8fd2762db0159e7b97beeb76bf5b9c)
@@ -1,17 +1,17 @@
 <?xml version="1.0" encoding="utf-8"?>
 <!DOCTYPE TS>
-<TS version="2.0" language="uk_UA" sourcelanguage="ru_RU">
+<TS version="2.0" language="uk_UA" sourcelanguage="en">
 <defaultcodec>UTF-8</defaultcodec>
 <context>
     <name>CTSPModel</name>
     <message>
-        <location filename="../src/tspmodel.cpp" line="51"/>
-        <source>Город %1</source>
+        <location filename="../src/tspmodel.cpp" line="52"/>
+        <source>City %1</source>
         <translation>Місто %1</translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="53"/>
+        <location filename="../src/tspmodel.cpp" line="54"/>
         <source>%1</source>
-        <translation type="unfinished"></translation>
+        <translation></translation>
     </message>
 </context>
@@ -19,138 +19,34 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="14"/>
-        <location filename="../ui/mainwindow.ui" line="14"/>
-        <source>Задача коммивояжера</source>
-        <translation>Задача комівояжера</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="74"/>
-        <location filename="../ui/mainwindow.ui" line="56"/>
-        <source>&amp;Вариант:</source>
-        <translation>&amp;Варіант:</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="97"/>
-        <location filename="../ui/mainwindow.ui" line="79"/>
-        <source>&amp;Городов:</source>
-        <translation>&amp;Міст:</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="169"/>
-        <location filename="../ui/mainwindow.ui" line="151"/>
-        <source>Заполнить таблицу случайными значениями</source>
-        <translation>Заповнити таблицю випадковими значеннями</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="172"/>
-        <location filename="../ui/mainwindow.ui" line="154"/>
-        <source>Случайно</source>
-        <translation>Випадково</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="182"/>
-        <location filename="../ui/mainwindow.ui" line="164"/>
-        <source>Решить текущую задачу</source>
-        <translation>Розв&apos;язати поточну задачу</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="185"/>
-        <location filename="../ui/mainwindow.ui" line="167"/>
-        <source>Решить</source>
-        <translation>Розв&apos;язати</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="252"/>
-        <location filename="../ui/mainwindow.ui" line="236"/>
-        <source>&amp;Файл</source>
-        <translation>&amp;Файл</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="259"/>
-        <location filename="../ui/mainwindow.ui" line="243"/>
-        <source>Со&amp;хранить</source>
-        <translation>&amp;Зберегти</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="279"/>
-        <location filename="../ui/mainwindow.ui" line="266"/>
-        <source>&amp;Настройки</source>
-        <translation>&amp;Налагодження</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="285"/>
-        <location filename="../ui/mainwindow.ui" line="272"/>
-        <source>&amp;Помощь</source>
-        <translation>&amp;Допомога</translation>
+        <location filename="../ui/mainwindow.ce.ui" line="90"/>
+        <location filename="../ui/mainwindow.ui" line="69"/>
+        <source>Number of variant</source>
+        <translation>Номер варіанту</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="113"/>
+        <location filename="../ui/mainwindow.ui" line="92"/>
+        <source>Number of cities</source>
+        <translation>Кількість міст, що проходить комівояжер</translation>
     </message>
     <message>
         <location filename="../ui/mainwindow.ui" line="315"/>
-        <source>&amp;Настройка печати</source>
-        <translation>&amp;Налагодження друку</translation>
+        <source>P&amp;rint setup...</source>
+        <translation>&amp;Налагодження друку...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="318"/>
+        <source>Setup printing</source>
+        <translation>Налагодити друк</translation>
     </message>
     <message>
         <location filename="../ui/mainwindow.ui" line="330"/>
-        <source>&amp;Печать...</source>
+        <source>&amp;Print...</source>
         <translation>&amp;Друк...</translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="325"/>
-        <location filename="../ui/mainwindow.ui" line="344"/>
-        <source>&amp;Ход решения</source>
-        <translation>&amp;Хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="336"/>
-        <location filename="../ui/mainwindow.ui" line="355"/>
-        <source>&amp;Граф решения</source>
-        <translation>&amp;Граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="362"/>
-        <location filename="../ui/mainwindow.ui" line="381"/>
-        <source>&amp;Создать</source>
-        <translation>&amp;Створити</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="377"/>
-        <location filename="../ui/mainwindow.ui" line="396"/>
-        <source>&amp;Открыть</source>
-        <translation>&amp;Відкрити</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="395"/>
-        <location filename="../ui/mainwindow.ui" line="414"/>
-        <source>&amp;Параметры</source>
-        <translation>&amp;Параметри</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="407"/>
-        <location filename="../ui/mainwindow.ui" line="426"/>
-        <source>&amp;Содежание</source>
-        <translation>&amp;Зміст</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="419"/>
-        <location filename="../ui/mainwindow.ui" line="438"/>
-        <source>&amp;Контекстная справка</source>
-        <translation>&amp;Контекстна допомога</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="431"/>
-        <location filename="../ui/mainwindow.ui" line="450"/>
-        <source>&amp;Про...</source>
-        <translation>&amp;Про...</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="443"/>
-        <location filename="../ui/mainwindow.ui" line="462"/>
-        <source>В&amp;ыход</source>
-        <translation>В&amp;ихід</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="446"/>
-        <location filename="../ui/mainwindow.ui" line="465"/>
-        <source>Выйти из программы</source>
-        <translation>Вийти з програми</translation>
+        <location filename="../ui/mainwindow.ui" line="333"/>
+        <source>Print solution results</source>
+        <translation>Роздрукувати результат розв&apos;язку</translation>
     </message>
     <message>
@@ -160,184 +56,334 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="353"/>
+        <location filename="../ui/mainwindow.ce.ui" line="503"/>
+        <location filename="../ui/mainwindow.ui" line="519"/>
+        <source>Ctrl+S</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="383"/>
+        <location filename="../ui/mainwindow.ui" line="399"/>
+        <source>Ctrl+N</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="17"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
+        <source>Travelling salesman problem</source>
+        <translation>Задача комівояжера</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="56"/>
+        <location filename="../ui/mainwindow.ui" line="35"/>
+        <source>Task</source>
+        <translation>Завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="77"/>
+        <location filename="../ui/mainwindow.ui" line="56"/>
+        <source>&amp;Variant:</source>
+        <translation>&amp;Варіант:</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="100"/>
+        <location filename="../ui/mainwindow.ui" line="79"/>
+        <source>&amp;Cities:</source>
+        <translation>&amp;Міст:</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="144"/>
+        <location filename="../ui/mainwindow.ui" line="123"/>
+        <source>Cost of travel from city to city</source>
+        <translation>Вартість переїзду з міста у місто</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="172"/>
+        <location filename="../ui/mainwindow.ui" line="151"/>
+        <source>Fill table with random numbers</source>
+        <translation>Заповнити таблицю випадковими значеннями</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="175"/>
+        <location filename="../ui/mainwindow.ui" line="154"/>
+        <source>Random</source>
+        <translation>Випадково</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="185"/>
+        <location filename="../ui/mainwindow.ui" line="164"/>
+        <source>Solve current task</source>
+        <translation>Розв&apos;язати поточну задачу</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="188"/>
+        <location filename="../ui/mainwindow.ui" line="167"/>
+        <source>Solve</source>
+        <translation>Розв&apos;язати</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="202"/>
+        <location filename="../ui/mainwindow.ui" line="181"/>
+        <source>Solution</source>
+        <translation>Розв&apos;язок</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="219"/>
+        <location filename="../ui/mainwindow.ui" line="198"/>
+        <source>Solution steps</source>
+        <translation>Хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="229"/>
+        <location filename="../ui/mainwindow.ui" line="208"/>
+        <source>Solution graph</source>
+        <translation>Граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="255"/>
+        <location filename="../ui/mainwindow.ui" line="236"/>
+        <source>&amp;File</source>
+        <translation>&amp;Файл</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="262"/>
+        <location filename="../ui/mainwindow.ui" line="243"/>
+        <source>&amp;Save</source>
+        <translation>&amp;Зберегти</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="282"/>
+        <location filename="../ui/mainwindow.ui" line="266"/>
+        <source>&amp;Settings</source>
+        <translation>&amp;Параметри</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="288"/>
+        <location filename="../ui/mainwindow.ui" line="272"/>
+        <source>&amp;Help</source>
+        <translation>&amp;Допомога</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="328"/>
+        <location filename="../ui/mainwindow.ui" line="344"/>
+        <source>Solution st&amp;eps</source>
+        <translation>&amp;Хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="331"/>
+        <location filename="../ui/mainwindow.ui" line="347"/>
+        <source>Save solution steps</source>
+        <translation>Зберегти хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="334"/>
+        <location filename="../ui/mainwindow.ui" line="350"/>
+        <source>Save solution steps only</source>
+        <translation>Зберегти тільки хід розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="342"/>
+        <location filename="../ui/mainwindow.ui" line="358"/>
+        <source>Solution &amp;graph</source>
+        <translation>&amp;Граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="345"/>
+        <location filename="../ui/mainwindow.ui" line="361"/>
+        <source>Save solution graph</source>
+        <translation>Зберегти граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="348"/>
+        <location filename="../ui/mainwindow.ui" line="364"/>
+        <source>Save solution graph only</source>
+        <translation>Зберегти тільки граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="356"/>
+        <location filename="../ui/mainwindow.ui" line="372"/>
+        <source>&amp;Solution</source>
+        <translation>&amp;Розв&apos;язок</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="359"/>
+        <location filename="../ui/mainwindow.ui" line="375"/>
+        <source>Save solution</source>
+        <translation>Зберегти розв&apos;язок</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="362"/>
+        <location filename="../ui/mainwindow.ui" line="378"/>
+        <source>Save solution steps and graph</source>
+        <translation>Зберегти хід та граф розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="371"/>
+        <location filename="../ui/mainwindow.ui" line="387"/>
+        <source>&amp;New</source>
+        <translation>&amp;Створити</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="374"/>
+        <location filename="../ui/mainwindow.ui" line="390"/>
+        <source>New</source>
+        <translation>Створити</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="377"/>
+        <location filename="../ui/mainwindow.ui" line="393"/>
+        <source>New task</source>
+        <translation>Нове завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="380"/>
+        <location filename="../ui/mainwindow.ui" line="396"/>
+        <source>Create new task</source>
+        <translation>Створити нове завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="395"/>
+        <location filename="../ui/mainwindow.ui" line="411"/>
+        <source>&amp;Open...</source>
+        <translation>&amp;Відкрити...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="398"/>
+        <location filename="../ui/mainwindow.ui" line="414"/>
+        <source>Open...</source>
+        <translation>Відкрити...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="401"/>
+        <location filename="../ui/mainwindow.ui" line="417"/>
+        <source>Open task</source>
+        <translation>Відкрити завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="404"/>
+        <location filename="../ui/mainwindow.ui" line="420"/>
+        <source>Open saved task</source>
+        <translation>Відкрити збережене завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="407"/>
+        <location filename="../ui/mainwindow.ui" line="423"/>
+        <source>Ctrl+O</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="416"/>
+        <location filename="../ui/mainwindow.ui" line="432"/>
+        <source>&amp;Preferences...</source>
+        <translation>&amp;Налагодження...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="419"/>
+        <location filename="../ui/mainwindow.ui" line="435"/>
+        <source>Preferences...</source>
+        <translation>Налагодження...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="422"/>
+        <location filename="../ui/mainwindow.ui" line="438"/>
+        <source>Application preferences</source>
+        <translation>Налагодження додатку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="434"/>
+        <location filename="../ui/mainwindow.ui" line="450"/>
+        <source>&amp;Contents</source>
+        <translation>&amp;Зміст</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="437"/>
+        <location filename="../ui/mainwindow.ui" line="453"/>
+        <source>Open help contents</source>
+        <translation>Відкрити зміст допомоги</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="449"/>
+        <location filename="../ui/mainwindow.ui" line="465"/>
+        <source>&amp;Context help</source>
+        <translation>&amp;Контекстна допомога</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="452"/>
+        <location filename="../ui/mainwindow.ui" line="468"/>
+        <source>Open context help</source>
+        <translation>Відкрити контекстну допомогу</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="461"/>
+        <location filename="../ui/mainwindow.ui" line="477"/>
+        <source>&amp;About...</source>
+        <translation>&amp;Про...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="464"/>
+        <location filename="../ui/mainwindow.ui" line="480"/>
+        <source>About...</source>
+        <translation>Про...</translation>
+    </message>
+    <message>
         <location filename="../ui/mainwindow.ce.ui" line="467"/>
-        <location filename="../ui/mainwindow.ui" line="372"/>
-        <location filename="../ui/mainwindow.ui" line="486"/>
-        <source>Ctrl+S</source>
-        <translation></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="368"/>
-        <location filename="../ui/mainwindow.ui" line="387"/>
-        <source>Ctrl+N</source>
-        <translation></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="386"/>
-        <location filename="../ui/mainwindow.ui" line="405"/>
-        <source>Ctrl+O</source>
-        <translation></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="53"/>
-        <location filename="../ui/mainwindow.ui" line="35"/>
-        <source>Задача</source>
-        <translation>Задача</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="87"/>
-        <location filename="../ui/mainwindow.ui" line="69"/>
-        <source>Номер варианта</source>
-        <translation>Номер варіану</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="141"/>
-        <location filename="../ui/mainwindow.ui" line="123"/>
-        <source>Стоимости переходов/переездов из города в город</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="199"/>
-        <location filename="../ui/mainwindow.ui" line="181"/>
-        <source>Решение</source>
-        <translation>Розв&apos;язок</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="216"/>
-        <location filename="../ui/mainwindow.ui" line="198"/>
-        <source>Ход решения</source>
-        <translation>Хід розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="226"/>
-        <location filename="../ui/mainwindow.ui" line="208"/>
-        <source>Граф решения</source>
-        <translation>Граф розв&apos;язку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="318"/>
-        <source>Настроить принтер для печати</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ui" line="333"/>
-        <source>Распечатать результаты решения</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="328"/>
-        <location filename="../ui/mainwindow.ui" line="347"/>
-        <source>Сохранить только хоод решения</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="339"/>
-        <location filename="../ui/mainwindow.ui" line="358"/>
-        <source>Сохранить только граф решения</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="347"/>
-        <location filename="../ui/mainwindow.ui" line="366"/>
-        <source>&amp;Решение</source>
-        <translation>&amp;Розв&apos;язок</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="350"/>
-        <location filename="../ui/mainwindow.ui" line="369"/>
-        <source>Сохранить ход и граф решения</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="365"/>
-        <location filename="../ui/mainwindow.ui" line="384"/>
-        <source>Создать новую задачу</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="380"/>
-        <location filename="../ui/mainwindow.ui" line="399"/>
-        <source>Открыть задачу</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="383"/>
-        <location filename="../ui/mainwindow.ui" line="402"/>
-        <source>Открыть сохраненное условие задачи</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="398"/>
-        <location filename="../ui/mainwindow.ui" line="417"/>
-        <source>Настройка параметров программмы</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="410"/>
-        <location filename="../ui/mainwindow.ui" line="429"/>
-        <source>Вызвать справку по программе</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="422"/>
-        <location filename="../ui/mainwindow.ui" line="441"/>
-        <source>Вызвать контекстную справку</source>
-        <translation>Викликати контекстну довідку</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="455"/>
-        <location filename="../ui/mainwindow.ui" line="474"/>
-        <source>&amp;Задачу</source>
-        <translation>&amp;Задачу</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="458"/>
-        <location filename="../ui/mainwindow.ui" line="477"/>
-        <source>Сохранить</source>
-        <translation>Зберегти</translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="461"/>
-        <location filename="../ui/mainwindow.ui" line="480"/>
-        <source>Сохранить задачу</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="464"/>
         <location filename="../ui/mainwindow.ui" line="483"/>
-        <source>Сохранить условие задачи в файл</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="104"/>
-        <source>Ошибка в данных</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="104"/>
-        <source>Ошибка в ячейке [Строка %1; Колонка %2]: Неверный формат данных.</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="113"/>
-        <source>Ошибка при решении</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../src/mainwindow.cpp" line="113"/>
-        <source>Во время решения задачи возникла ошибка</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="434"/>
-        <location filename="../ui/mainwindow.ui" line="453"/>
-        <source>Получить информацию о программе</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="110"/>
-        <location filename="../ui/mainwindow.ui" line="92"/>
-        <source>Количество городов, которые обходит коммивояжер</source>
-        <translation type="unfinished"></translation>
+        <source>About application</source>
+        <translation>Про додаток</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="476"/>
+        <location filename="../ui/mainwindow.ui" line="492"/>
+        <source>E&amp;xit</source>
+        <translation>В&amp;ихід</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="479"/>
+        <location filename="../ui/mainwindow.ui" line="495"/>
+        <source>Exit application</source>
+        <translation>Вийти з додатку</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="491"/>
+        <location filename="../ui/mainwindow.ui" line="507"/>
+        <source>&amp;Task...</source>
+        <translation>&amp;Завдання...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="494"/>
+        <location filename="../ui/mainwindow.ui" line="510"/>
+        <source>Task...</source>
+        <translation>Завдання...</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="497"/>
+        <location filename="../ui/mainwindow.ui" line="513"/>
+        <source>Save task</source>
+        <translation>Зберегти завдання</translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ce.ui" line="500"/>
+        <location filename="../ui/mainwindow.ui" line="516"/>
+        <source>Save task to file</source>
+        <translation>Зберегти завдання до файлу</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="125"/>
+        <source>Data error</source>
+        <translation>Помилка даних</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="125"/>
+        <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
+        <translation>Помилка у комірці  [Рядок %1; Колонка %2]: Невірний формат даних.</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="134"/>
+        <source>Solution error</source>
+        <translation>Помилка розв&apos;язку</translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="134"/>
+        <source>There was an error while solving the task.</source>
+        <translation>Під час розв&apos;язання задачі виникла помилка.</translation>
     </message>
 </context>
@@ -345,18 +391,48 @@
     <name>SettingsDialog</name>
     <message>
+        <location filename="../ui/settingsdialog.ui" line="41"/>
+        <source>background-color: #0080C0</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="235"/>
+        <source>Print settings:</source>
+        <translation>Налагодження друку:</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="249"/>
+        <source>&amp;Left margin:</source>
+        <translation>&amp;Лівий відступ:</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="262"/>
+        <source>Left border margin for page</source>
+        <translation>Лівий відступ від межі сторінки під час друку</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="329"/>
+        <source>Restore main window state and position on application restart</source>
+        <translation>Відновлювати стан та розмір головного вікна пысля перезапуску додатку</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="332"/>
+        <source>Save main window state and position</source>
+        <translation>Зберегти стан та розміщення головного вікна</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ui" line="403"/>
+        <source>Hover mouse pointer over dialog elements to get additional help</source>
+        <translation>Наведіть покажчик миші на елемент ділогу, щоб отримати підказку</translation>
+    </message>
+    <message>
         <location filename="../ui/settingsdialog.ce.ui" line="14"/>
         <location filename="../ui/settingsdialog.ui" line="14"/>
-        <source>Параметры</source>
+        <source>Preferences</source>
         <translation>Параметри</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="41"/>
-        <source>background-color: #0080C0</source>
-        <translation>background-color: #0080C0</translation>
     </message>
     <message>
         <location filename="../ui/settingsdialog.ce.ui" line="100"/>
         <location filename="../ui/settingsdialog.ui" line="151"/>
-        <source>Случайные значения:</source>
+        <source>Random values:</source>
         <translation>Випадкові значення:</translation>
     </message>
@@ -364,119 +440,86 @@
         <location filename="../ui/settingsdialog.ce.ui" line="114"/>
         <location filename="../ui/settingsdialog.ui" line="165"/>
-        <source>Ми&amp;нимум:</source>
-        <translation>Мі&amp;німум:</translation>
+        <source>&amp;Minimal:</source>
+        <translation>&amp;Мінімум:</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="127"/>
+        <location filename="../ui/settingsdialog.ui" line="178"/>
+        <source>Minimum for random number generation</source>
+        <translation>Нажня межа для генерації випадкових значень</translation>
     </message>
     <message>
         <location filename="../ui/settingsdialog.ce.ui" line="150"/>
         <location filename="../ui/settingsdialog.ui" line="201"/>
-        <source>&amp;Максимум:</source>
-        <translation>&amp;Максимум:</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="235"/>
-        <source>Настройки печати:</source>
-        <translation>Налагодження друку:</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="243"/>
-        <source>&amp;Левый отступ:</source>
-        <translation>&amp;Лівий відступ:</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="205"/>
-        <location filename="../ui/settingsdialog.ui" line="280"/>
-        <source>&amp;Шрифт...</source>
-        <translation>&amp;Шрифт...</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="302"/>
-        <source>Сохранять состояние и положение главного окна</source>
-        <translation>Зберегти стан та розміщення головного вікна</translation>
-    </message>
-    <message>
-        <source>Подсказка</source>
-        <translation type="obsolete">Підказка</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="353"/>
-        <location filename="../ui/settingsdialog.ui" line="395"/>
-        <source>&amp;OK</source>
-        <translation>&amp;OK</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="373"/>
-        <location filename="../ui/settingsdialog.ui" line="415"/>
-        <source>&amp;Отмена</source>
-        <translation>&amp;Скасувати</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="320"/>
-        <location filename="../ui/settingsdialog.ui" line="350"/>
-        <source>Помощь</source>
-        <translation>Допомога</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="317"/>
-        <location filename="../ui/settingsdialog.ui" line="347"/>
-        <source>Получить помощь по настройкам</source>
-        <translation>Отримати допомогу по налагодженням</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="127"/>
-        <location filename="../ui/settingsdialog.ui" line="178"/>
-        <source>Нижняя граница для генерации случайных значений</source>
-        <translation type="unfinished"></translation>
+        <source>Ma&amp;ximal:</source>
+        <translation>М&amp;аксимум:</translation>
     </message>
     <message>
         <location filename="../ui/settingsdialog.ce.ui" line="163"/>
         <location filename="../ui/settingsdialog.ui" line="214"/>
-        <source>Верхняя граница для генерации случайных значений</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="256"/>
-        <source>Размер отступа от левого края страницы</source>
-        <translation type="unfinished"></translation>
+        <source>Maximum for random number generation</source>
+        <translation>Верхня межа для генерації випадкових значень</translation>
     </message>
     <message>
         <location filename="../ui/settingsdialog.ce.ui" line="202"/>
-        <location filename="../ui/settingsdialog.ui" line="277"/>
-        <source>Задать параметры шрифта, используемого при печати</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="252"/>
-        <source>Сохранять состояние и
-положение главного окна</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="314"/>
-        <location filename="../ui/settingsdialog.ui" line="344"/>
-        <source>Справка</source>
-        <translation>Довідка</translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="350"/>
-        <location filename="../ui/settingsdialog.ui" line="392"/>
-        <source>Сохранить новые параметры</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="370"/>
-        <location filename="../ui/settingsdialog.ui" line="412"/>
-        <source>Закрыть окно без сохранения параметров</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ce.ui" line="249"/>
-        <location filename="../ui/settingsdialog.ui" line="299"/>
-        <source>Восстанавливать состояние и размеры окна после перезапуска программы</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/settingsdialog.ui" line="370"/>
-        <source>Наведите указатель мыши на элемент диалога, чтоб получить подсказку</source>
-        <translation type="unfinished"></translation>
+        <location filename="../ui/settingsdialog.ui" line="288"/>
+        <source>Font color for printing</source>
+        <translation>Колір шрифта для друку</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="205"/>
+        <location filename="../ui/settingsdialog.ui" line="291"/>
+        <source>&amp;Color...</source>
+        <translation>&amp;Колір...</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="219"/>
+        <location filename="../ui/settingsdialog.ui" line="305"/>
+        <source>Font face for printing</source>
+        <translation>Вигляд шрифта для друку</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="222"/>
+        <location filename="../ui/settingsdialog.ui" line="308"/>
+        <source>&amp;Font...</source>
+        <translation>&amp;Шрифт...</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="287"/>
+        <location filename="../ui/settingsdialog.ce.ui" line="293"/>
+        <location filename="../ui/settingsdialog.ui" line="377"/>
+        <location filename="../ui/settingsdialog.ui" line="383"/>
+        <source>Help</source>
+        <translation>Допомога</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="290"/>
+        <location filename="../ui/settingsdialog.ui" line="380"/>
+        <source>Get preferences help</source>
+        <translation>Отримати допомогу по налагодженням</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="323"/>
+        <location filename="../ui/settingsdialog.ui" line="425"/>
+        <source>Save new preferences</source>
+        <translation>Зберегти нові параметри</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="326"/>
+        <location filename="../ui/settingsdialog.ui" line="428"/>
+        <source>&amp;OK</source>
+        <translation></translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="343"/>
+        <location filename="../ui/settingsdialog.ui" line="445"/>
+        <source>Close without saving preferences</source>
+        <translation>Закрити вікно без збереження параметрів</translation>
+    </message>
+    <message>
+        <location filename="../ui/settingsdialog.ce.ui" line="346"/>
+        <location filename="../ui/settingsdialog.ui" line="448"/>
+        <source>&amp;Cancel</source>
+        <translation>&amp;Скасувати</translation>
     </message>
 </context>
